'****************************************************************
'*  Name    :  VIDEO SELECTOR.BAS                               *
'*  Author  : [MCU PIC16F676]                                   *
'*  Notice  : Copyright (c) 2004 [set under view...options]     *
'*          : All Rights Reserved                               *
'*  Date    : 29/5/2006                                         *
'*  Version : 1.0                                               *
'*  Notes   : NATTAPON JONGROEKMONGKOL                          *
'*          :                                                   *
'****************************************************************
'****** DEFINE CHIP'S CONFIGURATION *****************************

DEFINE OSCCAL_1K     1          ' Oscillator calibration for 1k device
TRISC = %00000000               ' PORTC is output
TRISA = %11111111	            ' Set PORTA to all input
ANSEL = %00000000               ' Set RA0,RA2,RA3 as analog port
CMCON = 7	                    ' Analog comparators off

DAT  var PORTC.5 ' PIC P5  connect  P9 74HC165
CLK  VAR PORTC.3 ' PIC P7  connect  P2 74HC165   
LAT  VAR PORTC.4 ' PIC P6  connect  P1 74HC165

'  PORTA.2  IS TEST LED
'  PORTA.4  IS MODE 
'  PORTA.5  IS SET

A  VAR BYTE
B  VAR BYTE
C  VAR BYTE
F1 VAR BYTE
K  VAR BYTE
I  VAR BYTE         ' READ DIP SW ACTIVE CH  
J  VAR BYTE         ' SELEC LOOP
   J=0              ' J=0 IS SLITE
   F1=0             ' J=1 IS SELEC
   K=0
   C=0
   
   LOW  PORTA.1     ' OFF  MODE
   pause  50   
   
        LOW  LAT               '
        HIGH LAT               ' READ Serial FORM 74LS165 
        SHIFTIN DAT,CLK,1,[I]  '
        
'*****************  LOOP_SLITE  *************************************         
        
LOOP_SLITE: 

        J=0              
        F1=0            
        K=0
        C=0
        GOSUB   DELAY1
        LOW  PORTA.1   ' OFF  MODE 
        PORTC=%00000000 

'-----------------  LOOP 1 SEC -------------------------------------            
  LOOP1:
        J1:
                GOSUB DELAY2
                C=0
                K=0
        J1_1:    
                F1=0
                HIGH  PORTA.2 
        J1_2:        
                FOR B=1 TO 10
                   IF PORTA.5=0 THEN J2
                   pause  100 
                   IF PORTA.4=0 THEN  LOOP_SELEC
                NEXT B 
                   
                   LOW  PORTA.2 
                   IF F1=1 THEN  J1_1
                   F1=1
                   C=C+1
                   IF C=3 THEN  AAA        
                           
                   goto  J1_2
                   
       AAA:        K=10    
                   goto  LOOP4
                   
'-----------------  LOOP 2 SEC -------------------------------------             
             
        J2:
                GOSUB DELAY2
                C=0
                K=0
        J2_1:   
                F1=0
                HIGH  PORTA.2 
        J2_2:        
                FOR B=1 TO 20
                   IF PORTA.5=0 THEN J3
                   pause  100 
                   IF PORTA.4=0 THEN  LOOP_SELEC
                NEXT B  
                   LOW  PORTA.2 
                   IF F1=1 THEN  J2_1
                   F1=1
                   C=C+1
                   IF C=3 THEN  BBB 
                   goto  J2_2   
       BBB:        K=20     
                   goto  LOOP4  
                   
'-----------------  LOOP 3 SEC -------------------------------------            
        J3:
                GOSUB DELAY2
                C=0
                K=0
        J3_1:   
                F1=0
                HIGH  PORTA.2 
        J3_2:        
                FOR B=1 TO 30
                   IF PORTA.5=0 THEN J4
                   pause  100 
                   IF PORTA.4=0 THEN  LOOP_SELEC
                NEXT B  
                   LOW  PORTA.2 
                   IF F1=1 THEN  J3_1
                   F1=1
                   C=C+1
                   IF C=3 THEN  CCC 
                   goto  J3_2  
       CCC:        K=30     
                   goto  LOOP4  
                             
'-----------------  LOOP 4 SEC -------------------------------------              
        J4:
                GOSUB DELAY2
                C=0
                K=0
        J4_1:   
                F1=0
                HIGH  PORTA.2 
        J4_2:        
                FOR B=1 TO 40
                   IF PORTA.5=0 THEN J5
                   pause  100 
                   IF PORTA.4=0 THEN  LOOP_SELEC
                NEXT B  
                   LOW  PORTA.2 
                   IF F1=1 THEN  J4_1
                   F1=1
                   C=C+1
                   IF C=3 THEN  DDD 
                   goto  J4_2  
        DDD:      K=40
                  goto  LOOP4
                       
'-----------------  LOOP 5 SEC -------------------------------------               
        J5:
                GOSUB DELAY2
                C=0
                K=0
        J5_1:   
                F1=0
                HIGH  PORTA.2 
        J5_2:        
                FOR B=1 TO 50
                   IF PORTA.5=0 THEN J1
                   pause  100 
                   IF PORTA.4=0 THEN  LOOP_SELEC
                NEXT B  
                   LOW  PORTA.2 
                   IF F1=1 THEN  J5_1
                   F1=1
                   C=C+1
                   IF C=3 THEN  EEE
                   goto  J5_2                 
         EEE:      K=50 
      
  LOOP4:
              GOSUB   DELAY1
              
'-----------------  LOOP TEST DIP SW  --------------------------------        
               
  LOOP5: 
             PORTC=%00000000
                IF PORTA.4=0 THEN  LOOP_SELEC
                LOW  PORTA.1    ' OFF  MODE
             IF I=%11111111 THEN  LOOP5
                HIGH  PORTA.1   ' ON  MODE                    
        S1:
                A=I&%0000001
             IF A=%00000001 THEN  S2 
                PORTC=%00000000 
                GOSUB  DELAY3
             
        S2: 
                A=I&%0000010
             IF A=%00000010 THEN  S3       
                PORTC=%00000001
                GOSUB DELAY3
        S3:
                A=I&%0000100
             IF A=%00000100 THEN  S4 
                PORTC=%00000010
                GOSUB  DELAY3
             
        S4:      
                A=I&%00001000
             IF A=%00001000 THEN  S5 
                PORTC=%00000011
                GOSUB  DELAY3
      
       S5:
                A=I&%00010000
             IF A=%00010000 THEN  S6
                PORTC=%00000100
                GOSUB  DELAY3
      
        S6:
                A=I&%00100000
             IF A=%00100000 THEN  S7
                PORTC=%00000101
                GOSUB  DELAY3
      
        S7:
                A=I&%01000000
             IF A=%01000000 THEN  S8
                PORTC=%000000110
                GOSUB  DELAY3
         
        S8:
                A=I&%10000000
             IF A=%10000000 THEN  S1
                PORTC=%000000111
                GOSUB  DELAY3  
             GOTO  S1

DELAY3:                                          '
                                                 '
                FOR B=1 TO K                     ' VARIABLE DELAY SET
                   pause  100                    '
                   IF PORTA.4=0 THEN  LOOP_SELEC '
                NEXT B                           '
              
                RETURN

'*****************  LOOP_SELEC ************************************* 
          
LOOP_SELEC: 
             LOW  PORTA.2   ' OFF  LED TEST
             LOW  PORTA.1   ' OFF  MODE           
             GOSUB   DELAY1
        LOOP: 
             PORTC=%00001111
                IF PORTA.4=0 THEN  LOOP_SLITE
                LOW  PORTA.1   ' OFF  MODE
             IF I=%11111111 THEN  LOOP
              HIGH  PORTA.1    ' ON  MODE   
               
'-----------------  LOOP TEST DIP SW  -------------------------------               
                                
        L1:
             A= I&%0000001
             IF A=%00000001 THEN  L2 
        L1_1: 
             GOSUB DELAY2
             IF PORTA.5=0 THEN L2 
             PORTC=%00000000 
                IF PORTA.4=0 THEN  LOOP_SLITE
             goto  L1_1
        L2: 
             A= I&%0000010
             IF A=%00000010 THEN  L3       
        L2_1: 
             GOSUB DELAY2
             IF PORTA.5=0 THEN L3
             PORTC=%00000001
                IF PORTA.4=0 THEN  LOOP_SLITE
             GOTO  L2_1
        L3:
             A= I&%0000100
             IF A=%00000100 THEN  L4 
        L3_1:
             GOSUB DELAY2
             IF PORTA.5=0 THEN L4
             PORTC=%00000010
                IF PORTA.4=0 THEN  LOOP_SLITE
             GOTO  L3_1
             
        L4:      
             A= I&%00001000
             IF A=%00001000 THEN  L5 
             
        L4_1:
             GOSUB DELAY2
             IF PORTA.5=0 THEN L5
             PORTC=%00000011
                IF PORTA.4=0 THEN  LOOP_SLITE
             GOTO  L4_1
      
       L5:
             A= I&%00010000
             IF A=%00010000 THEN  L6
       L5_1:
             GOSUB DELAY2
             IF PORTA.5=0 THEN L6
             PORTC=%00000100
                IF PORTA.4=0 THEN  LOOP_SLITE
             GOTO  L5_1
      
        L6:
             A= I&%00100000
             IF A=%00100000 THEN  L7
       L6_1:
             GOSUB DELAY2
             IF PORTA.5=0 THEN L7
             PORTC=%00000101
                IF PORTA.4=0 THEN  LOOP_SLITE
             GOTO  L6_1
      
        L7:
             A= I&%01000000
             IF A=%01000000 THEN  L8
           
        L7_1:         
             GOSUB DELAY2
             IF PORTA.5=0 THEN L8
             PORTC=%00000110
                IF PORTA.4=0 THEN  LOOP_SLITE
             GOTO  L7_1
         
        L8:
             A= I&%10000000
             IF A=%10000000 THEN  L1
               
        L8_1:     
             GOSUB DELAY2
             IF PORTA.5=0 THEN L1
             PORTC=%00000111
                IF PORTA.4=0 THEN  LOOP_SLITE
             GOTO  L8_1
             
'-----------------  LOOP DEBOUNCE KEY  ------------------------------- 
     
DELAY1:     
       while  PORTA.4=0: wend
       pause   50
       return
DELAY2:     
       while  PORTA.5=0: wend
       pause   50
       return  
       
       
       END
         
        
        
        
        
        
        
        
        
        

